Index: tmp/org.txm.chartsengine.jfreechart.core/src/org/txm/chartsengine/jfreechart/core/JFCChartCreator.java
===================================================================
--- tmp/org.txm.chartsengine.jfreechart.core/src/org/txm/chartsengine/jfreechart/core/JFCChartCreator.java	(revision 2719)
+++ tmp/org.txm.chartsengine.jfreechart.core/src/org/txm/chartsengine/jfreechart/core/JFCChartCreator.java	(revision 2720)
@@ -1,20 +1,18 @@
 package org.txm.chartsengine.jfreechart.core;
 
 import java.awt.Color;
-import java.io.File;
 import java.util.ArrayList;
 
 import org.jfree.chart.JFreeChart;
-import org.jfree.chart.axis.SymbolAxis;
 import org.jfree.chart.plot.CategoryPlot;
 import org.jfree.chart.plot.XYPlot;
 import org.txm.chartsengine.core.ChartCreator;
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
 import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.jfreechart.core.renderers.interfaces.IRendererWithItemSelection;
+import org.txm.utils.logger.Log;
 
 
-
 /**
  * JFreeChart base chart creator.
  * 
@@ -25,22 +23,33 @@
  * @author sjacquot
  *
  */
-public abstract class JFCChartCreator extends ChartCreator {
+public abstract class JFCChartCreator<R extends ChartResult> extends ChartCreator<JFCChartsEngine, R> {
 	
+	// @Override
+	// public final Object createChart(ChartResult result) {
+	// if ("java".equals(this.getChartsEngine().getOutputFormat())) {
+	// return _createJFreeChart(result);
+	// }
+	// else {
+	// return createChartFile(result);
+	// }
+	// }
 	
 	@Override
-	public void updateChart(ChartResult result) {
+	public abstract JFreeChart createChart(R result);
+	
+	@Override
+	public void updateChart(R result) {
 		this.updateChart(result, true);
 	}
 	
-	
 	/**
 	 * Updates the chart according to the shared parameters, also applies the current theme to the chart and the user renderer settings.
 	 * 
 	 * @param result
 	 * @param applyTheme
 	 */
-	public void updateChart(ChartResult result, boolean applyTheme) {
+	public void updateChart(R result, boolean applyTheme) {
 		
 		// Java object
 		if (result.getChart() instanceof JFreeChart) {
@@ -102,11 +111,17 @@
 			
 			chart.setNotify(true);
 		}
-		// File
-		else if (result.getChart() instanceof File) {
-			// creates a new chart but using the same file
-			this.createChartFile(result, (File) result.getChart());
+		else {
+			Log.severe("Error: JFCChartCreator only manage JFC charts: " + result.getChart());
 		}
+		// // File
+		// else if (result.getChart() instanceof File) {
+		// // creates a new chart but using the same file
+		// this.createChartFile(result, (File) result.getChart());
+		// }
+		// else { // FIXME hack to set the chart File
+		// result.setChart(this.createChartFile(result));
+		// }
 	}
 	
 	
@@ -130,21 +145,8 @@
 		return colors;
 	}
 	
-	
-	
-	
 	@Override
-	public Class getChartsEngineClass() {
+	public Class<JFCChartsEngine> getChartsEngineClass() {
 		return JFCChartsEngine.class;
 	}
-	
-	/**
-	 * Convenience method.
-	 * 
-	 * @return the casted charts engine.
-	 */
-	protected JFCChartsEngine getChartsEngine() {
-		return (JFCChartsEngine) this.chartsEngine;
-	}
-	
 }
Index: tmp/org.txm.wordcloud.core/src/org/txm/wordcloud/core/chartsengine/r/RWordCloudChartCreator.java
===================================================================
--- tmp/org.txm.wordcloud.core/src/org/txm/wordcloud/core/chartsengine/r/RWordCloudChartCreator.java	(revision 2719)
+++ tmp/org.txm.wordcloud.core/src/org/txm/wordcloud/core/chartsengine/r/RWordCloudChartCreator.java	(revision 2720)
@@ -2,22 +2,20 @@
 
 import java.io.File;
 
-import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.r.core.RChartCreator;
-import org.txm.chartsengine.r.core.RChartsEngine;
 import org.txm.statsengine.core.StatException;
 import org.txm.statsengine.r.core.RWorkspace;
 import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
 import org.txm.wordcloud.core.functions.WordCloud;
 
-public class RWordCloudChartCreator extends RChartCreator {
+public class RWordCloudChartCreator extends RChartCreator<WordCloud> {
 	
 	
 	@Override
-	public File createChartFile(ChartResult result, File file) {
+	public File createChart(WordCloud result, File file) {
 		
 		try {
-			WordCloud wordCloud = (WordCloud) result;
+			WordCloud wordCloud = result;
 			
 			
 			// parameters
@@ -68,7 +66,7 @@
 			// System.out.println("ploting...");
 			// rw.plot(svgFile, cmd, device);
 			
-			((RChartsEngine) this.chartsEngine).plot(file, cmd);
+			this.chartsEngine.plot(file, cmd);
 			
 			
 			// System.out.println("cleaning");
@@ -88,7 +86,7 @@
 	}
 	
 	@Override
-	public Class getResultDataClass() {
+	public Class<WordCloud> getResultDataClass() {
 		return WordCloud.class;
 	}
 	
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/LexiconEditor.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/LexiconEditor.java	(revision 2719)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/LexiconEditor.java	(revision 2720)
@@ -2,6 +2,7 @@
 package org.txm.index.rcp.editors;
 
 import org.eclipse.swt.layout.GridData;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 
 /**
  * Extends the index editor to:
@@ -13,7 +14,8 @@
 public class LexiconEditor extends IndexEditor {
 	
 	@Override
-	public void _createPartControl() {
+	public void _createPartControl() throws CqiClientException {
+		
 		super._createPartControl();
 		
 		this.propertiesSelector.setMaxPropertyNumber(1);
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/PartitionIndexEditor.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/PartitionIndexEditor.java	(revision 2719)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/PartitionIndexEditor.java	(revision 2720)
@@ -36,9 +36,6 @@
 import org.eclipse.swt.events.SelectionListener;
 import org.eclipse.swt.graphics.Font;
 import org.eclipse.swt.graphics.FontData;
-import org.eclipse.swt.layout.FormAttachment;
-import org.eclipse.swt.layout.FormData;
-import org.eclipse.swt.layout.FormLayout;
 import org.eclipse.swt.layout.GridData;
 import org.eclipse.swt.layout.GridLayout;
 import org.eclipse.swt.widgets.Composite;
@@ -68,6 +65,7 @@
 import org.txm.searchengine.core.IQuery;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.CQPCorpus;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.searchengine.cqp.corpus.Part;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.WordProperty;
@@ -76,7 +74,8 @@
 
 /**
  * Partition index editor.
- *
+ * TODO inherit the IndexEditor and add more columns to the table
+ * 
  * @author mdecorde
  */
 public class PartitionIndexEditor extends TXMEditor<PartitionIndex> {
@@ -161,10 +160,11 @@
 	 * Creates the part control.
 	 *
 	 * @param parent the parent
+	 * @throws CqiClientException
 	 * @see org.eclipse.ui.part.WorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
 	 */
 	@Override
-	public void _createPartControl() {
+	public void _createPartControl() throws CqiClientException {
 		
 		
 		this.index = this.getResult();
@@ -229,78 +229,21 @@
 		// Listener
 		propertiesSelector.addSelectionListener(computeSelectionListener);
 		
-		
 		// extended parameters
 		
-		// FIXME: old version
 		// Filters
-		// Composite filtercontrols = new Composite(paramArea, SWT.NONE);
-		// FormData filtersLayoutData = new FormData();
-		// filtersLayoutData.top = new FormAttachment(queryArea, 0);
-		// filtersLayoutData.bottom = new FormAttachment(100);
-		// filtersLayoutData.left = new FormAttachment(0);
-		// filtersLayoutData.right = new FormAttachment(100);
-		// filtercontrols.setLayoutData(filtersLayoutData);
-		//
-		// GridLayout gridLayout = new GridLayout();
-		// gridLayout.numColumns = 9;
-		// gridLayout.makeColumnsEqualWidth = false;
-		// filtercontrols.setLayout(gridLayout);
-		//
-		// Label tmp = new Label(filtercontrols, SWT.NONE);
-		// tmp.setText(TXMCoreMessages.common_thresholds);
-		// tmp.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false));
-		//
-		// Label lFmin = new Label(filtercontrols, SWT.NONE);
-		// lFmin.setText(TXMCoreMessages.common_fMin);
-		// lFmin.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false));
-		//
-		// GridData fieldsGridData = new GridData(GridData.VERTICAL_ALIGN_END);
-		// fieldsGridData.minimumWidth = 100;
-		//
-		// fMinSpinner = new Spinner(filtercontrols, SWT.BORDER);
-		// fMinSpinner.setMinimum(0);
-		// fMinSpinner.setMaximum(9999999);
-		// fMinSpinner.setIncrement(1);
-		// fMinSpinner.setPageIncrement(100);
-		// fMinSpinner.setLayoutData(fieldsGridData);
-		// fMinSpinner.addKeyListener(computeKeyListener);
-		// fMinSpinner.addSelectionListener(computeSelectionListener);
-		//
-		// Label lFmax = new Label(filtercontrols, SWT.NONE);
-		// lFmax.setText(TXMCoreMessages.common_fMax);
-		// lFmax.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false));
-		//
-		// fMaxSpinner = new Spinner(filtercontrols, SWT.BORDER);
-		// fMaxSpinner.setMinimum(0);
-		// fMaxSpinner.setMaximum(9999999);
-		// fMaxSpinner.setIncrement(1);
-		// fMaxSpinner.setPageIncrement(100);
-		// fMaxSpinner.setLayoutData(fieldsGridData);
-		// fMaxSpinner.addKeyListener(computeKeyListener);
-		// fMaxSpinner.addSelectionListener(computeSelectionListener);
-		//
-		// Label lVmax = new Label(filtercontrols, SWT.NONE);
-		// lVmax.setText(TXMCoreMessages.VMAX_1);
-		// lVmax.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false));
-		//
-		// vMaxSpinner = new Spinner(filtercontrols, SWT.BORDER);
-		// vMaxSpinner.setMinimum(0);
-		// vMaxSpinner.setMaximum(9999999);
-		// vMaxSpinner.setIncrement(1);
-		// vMaxSpinner.setPageIncrement(100);
-		// vMaxSpinner.setLayoutData(fieldsGridData);
-		// vMaxSpinner.addKeyListener(computeKeyListener);
-		// vMaxSpinner.addSelectionListener(computeSelectionListener);
-		
-		
-		// FIXME: new version
-		// Filters
 		ThresholdsGroup thresholdsGroup = new ThresholdsGroup(this.getExtendedParametersGroup(), this);
 		this.fMinSpinner = thresholdsGroup.getFMinSpinner();
 		this.fMaxSpinner = thresholdsGroup.getFMaxSpinner();
 		this.vMaxSpinner = thresholdsGroup.getVMaxSpinner();
 		
+		CQPCorpus corpus = getResult().getFirstParent(MainCorpus.class);
+		if (corpus != null) {
+			this.vMaxSpinner.setMaximum(corpus.getSize());
+			this.fMaxSpinner.setMaximum(corpus.getSize());
+			this.fMinSpinner.setMaximum(corpus.getSize());
+		}
+		
 		Label lNLigneppage = new Label(this.getExtendedParametersGroup(), SWT.NONE);
 		lNLigneppage.setText(IndexUIMessages.pageSize);
 		
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 2719)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 2720)
@@ -67,6 +67,7 @@
 import org.txm.searchengine.core.IQuery;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.CQPCorpus;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.WordProperty;
 import org.txm.statsengine.r.rcp.views.RVariablesView;
@@ -158,10 +159,11 @@
 	 * Creates the part control.
 	 *
 	 * @param parent the parent
+	 * @throws CqiClientException
 	 * @see org.eclipse.ui.part.WorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
 	 */
 	@Override
-	public void _createPartControl() {
+	public void _createPartControl() throws CqiClientException {
 		
 		
 		this.index = this.getResult();
@@ -236,6 +238,12 @@
 		this.fMaxSpinner = thresholdsGroup.getFMaxSpinner();
 		this.vMaxSpinner = thresholdsGroup.getVMaxSpinner();
 		
+		CQPCorpus corpus = getResult().getFirstParent(MainCorpus.class);
+		if (corpus != null) {
+			this.vMaxSpinner.setMaximum(corpus.getSize());
+			this.fMaxSpinner.setMaximum(corpus.getSize());
+			this.fMinSpinner.setMaximum(corpus.getSize());
+		}
 		
 		// FIXME: SJ: we should create a widget class for the number of results per page
 		// Number of results per page
Index: tmp/org.txm.specificities.core/src/org/txm/specificities/core/chartsengine/r/RSpecificitiesBarChartCreator.java
===================================================================
--- tmp/org.txm.specificities.core/src/org/txm/specificities/core/chartsengine/r/RSpecificitiesBarChartCreator.java	(revision 2719)
+++ tmp/org.txm.specificities.core/src/org/txm/specificities/core/chartsengine/r/RSpecificitiesBarChartCreator.java	(revision 2720)
@@ -3,7 +3,6 @@
 import java.io.File;
 
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
-import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.r.core.RChartCreator;
 import org.txm.specificities.core.functions.SpecificitiesSelection;
 import org.txm.specificities.core.messages.SpecificitiesCoreMessages;
@@ -16,20 +15,21 @@
 
 /**
  * Creates a bar chart from the specified <code>SpecificitiesSelection</code> result.
+ * 
  * @author sjacquot
  *
  */
-public class RSpecificitiesBarChartCreator extends RChartCreator {
-
-
+public class RSpecificitiesBarChartCreator extends RChartCreator<SpecificitiesSelection> {
 	
+	
+	
 	@Override
-	public File createChartFile(ChartResult result, File file) {
-
+	public File createChart(SpecificitiesSelection result, File file) {
+		
 		try {
 			
-			SpecificitiesSelection specificitiesSelection = (SpecificitiesSelection) result;
-
+			SpecificitiesSelection specificitiesSelection = result;
+			
 			// parameters
 			boolean transpose = specificitiesSelection.isGroupingByLines();
 			boolean drawBars = specificitiesSelection.isDrawingBars();
@@ -37,143 +37,146 @@
 			float banality = specificitiesSelection.getBanality();
 			int renderingColorMode = result.getRenderingColorsMode();
 			
-			//boolean grayscale = (renderingColorMode == ChartsEngine.RENDERING_GRAYSCALE_MODE);
+			// boolean grayscale = (renderingColorMode == ChartsEngine.RENDERING_GRAYSCALE_MODE);
 			
-	
-
+			
+			
 			// TODO: should filter max and min here
 			// specIndex
-
+			
 			Matrix spec = new DoubleMatrix(specificitiesSelection.getSelectedSpecificitiesIndex());
 			Vector types = new VectorImpl(specificitiesSelection.getSelectedTypeNames());
 			Vector parts = new VectorImpl(specificitiesSelection.getSelectedPartNames());
-
+			
 			RWorkspace rw = RWorkspace.getRWorkspaceInstance();
 			rw.eval("rownames(" + spec.getSymbol() + ") <- " + types.getSymbol() + ";"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 			rw.eval("colnames(" + spec.getSymbol() + ") <- " + parts.getSymbol() + ";"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-
-			//System.out.println(""+"barplot(" + spec.getSymbol() + ", beside=T, legend.text=rownames(" + spec.getSymbol() + "));"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
-
+			
+			// System.out.println(""+"barplot(" + spec.getSymbol() + ", beside=T, legend.text=rownames(" + spec.getSymbol() + "));"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
+			
 			String matrix = spec.getSymbol();
 			if (transpose)
-				matrix = "t("+matrix+")"; //$NON-NLS-1$ //$NON-NLS-2$
-
-
+				matrix = "t(" + matrix + ")"; //$NON-NLS-1$ //$NON-NLS-2$
+			
+			
 			String names = parts.getSymbol();
 			if (transpose)
 				names = types.getSymbol();
-
+			
 			String legend = types.getSymbol();
 			if (transpose)
 				legend = parts.getSymbol();
-
-
+			
+			
 			// Title
 			String title = "";
-			if(result.getBooleanParameterValue(ChartsEnginePreferences.SHOW_TITLE))	{
-				title = specificitiesSelection.getName();	
+			if (result.getBooleanParameterValue(ChartsEnginePreferences.SHOW_TITLE)) {
+				title = specificitiesSelection.getName();
 			}
 			
-
+			
 			// Colors
 			int itemsCount = 0;
-			 // to put one color per part
+			// to put one color per part
 			if (transpose) {
 				itemsCount = specificitiesSelection.getSelectedPartNames().length;
 			}
 			// to put one color per word
-			else	{
-				itemsCount = specificitiesSelection.getSelectedTypeNames().size();				
+			else {
+				itemsCount = specificitiesSelection.getSelectedTypeNames().size();
 			}
-
+			
 			String[] colors = new String[itemsCount];
 			String[] allColors = this.getChartsEngine().getTheme().getPaletteAsHexFor(renderingColorMode, itemsCount);
-
-			for (int i = 0 ; i < itemsCount ; i++) {
+			
+			for (int i = 0; i < itemsCount; i++) {
 				colors[i] = allColors[i % allColors.length];
 			}
 			this.getChartsEngine().setColors(colors);
 			
-
 			
-			//String cmd = "op <- par(mar=c(5.5,5,5,5), xpd=TRUE);\n"; //$NON-NLS-1$
+			
+			// String cmd = "op <- par(mar=c(5.5,5,5,5), xpd=TRUE);\n"; //$NON-NLS-1$
 			String cmd = "op <- par(mar=c(5.5,5,5,5));\n"; //$NON-NLS-1$
-
+			
 			if (drawBars) {
-				cmd += 	"mat <- "+matrix+";\n" + //$NON-NLS-1$ //$NON-NLS-2$
-						"draw <- barplot(mat, space=c(1,3), col=colors"+ //$NON-NLS-1$
-						", horiz=F, las=2, names.arg="+names+", main=\""+title+ //$NON-NLS-1$ //$NON-NLS-2$
-						"\", beside=T, xpd=TRUE);\n" +  //$NON-NLS-1$ //$NON-NLS-2$
+				cmd += "mat <- " + matrix + ";\n" + //$NON-NLS-1$ //$NON-NLS-2$
+						"draw <- barplot(mat, space=c(1,3), col=colors" + //$NON-NLS-1$
+						", horiz=F, las=2, names.arg=" + names + ", main=\"" + title + //$NON-NLS-1$ //$NON-NLS-2$
+						"\", beside=T, xpd=TRUE);\n" +  //$NON-NLS-1$
 						// removed : legend.text="+legend + "
-						//"rm(op);" + //$NON-NLS-1$
-						"W2 <- 100000;\n"+//$NON-NLS-1$
-						"lines(c(0,W2), c(-"+banality+", -"+banality+"), lty=2);\n" + // seuil banalité inférieur //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-						"lines(c(0,W2), c("+banality+", "+banality+"), lty=2);\n" + // seuil banalité supérieur //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-						"lines(c(0,W2), c(0,0), lty=1);\n"+ //$NON-NLS-1$
+						// "rm(op);" + //$NON-NLS-1$
+						"W2 <- 100000;\n" +//$NON-NLS-1$
+						"lines(c(0,W2), c(-" + banality + ", -" + banality + "), lty=2);\n" + // seuil banalité inférieur //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+						"lines(c(0,W2), c(" + banality + ", " + banality + "), lty=2);\n" + // seuil banalité supérieur //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+						"lines(c(0,W2), c(0,0), lty=1);\n" + //$NON-NLS-1$
 						"\n"; //$NON-NLS-1$
-			} else {
-				//compute the hist but dont show the bar
-				cmd += 	"mat <- "+matrix+";\n" + //$NON-NLS-1$ //$NON-NLS-2$
-						"draw <- barplot(mat, space=c(1,3), col=\"white\", border=NA, horiz=F, las=2, names.arg="+names+", main=\""+title+"\", beside=T);\n"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-						//"rm(op);\n"; //$NON-NLS-1$
 			}
-
+			else {
+				// compute the hist but dont show the bar
+				cmd += "mat <- " + matrix + ";\n" + //$NON-NLS-1$ //$NON-NLS-2$
+						"draw <- barplot(mat, space=c(1,3), col=\"white\", border=NA, horiz=F, las=2, names.arg=" + names + ", main=\"" + title + "\", beside=T);\n"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+				// "rm(op);\n"; //$NON-NLS-1$
+			}
+			
 			if (drawLines) {
 				if (transpose) {
-					cmd +=	"for(i in 1:length(draw[1,])){\n" + //$NON-NLS-1$
+					cmd += "for(i in 1:length(draw[1,])){\n" + //$NON-NLS-1$
 							"lines(draw[,i], mat[,i], col=colors[[i]]);\n" + //$NON-NLS-1$
 							"}\n"; //$NON-NLS-1$
-				} else {
-					cmd +=	"for(i in 1:length(draw[,1])){\n" + //$NON-NLS-1$
+				}
+				else {
+					cmd += "for(i in 1:length(draw[,1])){\n" + //$NON-NLS-1$
 							"lines(draw[i,], mat[i,], col=colors[[i]]);\n" + //$NON-NLS-1$
 							"}\n"; //$NON-NLS-1$
 				}
 				if (!drawBars) {
 					if (transpose) {
-						cmd +=	"for(i in 1:length(draw[1,])){\n" + //$NON-NLS-1$
-								"text(draw[,i], 0, label="+legend+", offset=0, srt=90);\n" + //$NON-NLS-1$ //$NON-NLS-2$
+						cmd += "for(i in 1:length(draw[1,])){\n" + //$NON-NLS-1$
+								"text(draw[,i], 0, label=" + legend + ", offset=0, srt=90);\n" + //$NON-NLS-1$ //$NON-NLS-2$
 								"lines(c(draw[[1,i]],draw[[length(draw[,i]),i]]), c(0,0))" + //$NON-NLS-1$
 								"}\n"; //$NON-NLS-1$
-					} else {
+					}
+					else {
 						cmd += "lines( c(0,99999), c(0,0))\n"; //$NON-NLS-1$
 					}
 				}
 			}
-
 			
+			
 			// Grid
-			if(result.getBooleanParameterValue(ChartsEnginePreferences.SHOW_GRID))	{
+			if (result.getBooleanParameterValue(ChartsEnginePreferences.SHOW_GRID)) {
 				cmd += this.getChartsEngine().getGridPlotCmd();
 			}
 			
 			// Legend
-			if(result.getBooleanParameterValue(ChartsEnginePreferences.SHOW_LEGEND))	{
-				if (drawBars)	{
-					cmd += "legend(\"topright\", "+legend+", inset = c(-0.2,0), col = colors, fill = colors, xpd=TRUE);\n"; //$NON-NLS-1$ //$NON-NLS-2$
+			if (result.getBooleanParameterValue(ChartsEnginePreferences.SHOW_LEGEND)) {
+				if (drawBars) {
+					cmd += "legend(\"topright\", " + legend + ", inset = c(-0.2,0), col = colors, fill = colors, xpd=TRUE);\n"; //$NON-NLS-1$ //$NON-NLS-2$
 				}
-				else	{
-					cmd += "legend(\"topright\", "+legend+", inset = c(-0.2,0), col = colors, lty = 1, xpd=TRUE);\n"; //$NON-NLS-1$ //$NON-NLS-2$
+				else {
+					cmd += "legend(\"topright\", " + legend + ", inset = c(-0.2,0), col = colors, lty = 1, xpd=TRUE);\n"; //$NON-NLS-1$ //$NON-NLS-2$
 				}
 			}
-
+			
 			// Plot all
 			this.getChartsEngine().plot(file, cmd);
-
-
+			
+			
 		}
 		catch (Exception e) {
 			Log.severe(SpecificitiesCoreMessages.bind(SpecificitiesCoreMessages.cantCreateSpecificitiesChartFileChartsEngineColonP0, this.getChartsEngine().getName()) + e);
 		}
-
+		
 		return file;
 	}
-
 	
-
-
+	
+	
+	
 	@Override
-	public Class getResultDataClass() {
+	public Class<SpecificitiesSelection> getResultDataClass() {
 		return SpecificitiesSelection.class;
 	}
-
-}
\ No newline at end of file
+	
+}
Index: tmp/org.txm.specificities.core/src/org/txm/specificities/core/chartsengine/jfreechart/JFCSpecificitiesBarChartCreator.java
===================================================================
--- tmp/org.txm.specificities.core/src/org/txm/specificities/core/chartsengine/jfreechart/JFCSpecificitiesBarChartCreator.java	(revision 2719)
+++ tmp/org.txm.specificities.core/src/org/txm/specificities/core/chartsengine/jfreechart/JFCSpecificitiesBarChartCreator.java	(revision 2720)
@@ -12,7 +12,6 @@
 import org.jfree.data.general.DatasetUtils;
 import org.jfree.data.xy.XYSeries;
 import org.jfree.data.xy.XYSeriesCollection;
-import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.chartsengine.jfreechart.core.JFCChartCreator;
 import org.txm.chartsengine.jfreechart.core.themes.base.ExtendedNumberAxis;
 import org.txm.chartsengine.jfreechart.core.themes.base.SymbolAxisBetweenTicks;
@@ -22,145 +21,146 @@
 
 /**
  * Creates a bar chart from the specified <code>SpecificitiesSelection</code> result.
+ * 
  * @author sjacquot
  *
  */
-public class JFCSpecificitiesBarChartCreator extends JFCChartCreator {
-
+public class JFCSpecificitiesBarChartCreator extends JFCChartCreator<SpecificitiesSelection> {
+	
 	@Override
-	public JFreeChart createChart(ChartResult result) {
-
-		SpecificitiesSelection specificitiesSelection = (SpecificitiesSelection) result;
-
+	public JFreeChart createChart(SpecificitiesSelection result) {
+		
+		SpecificitiesSelection specificitiesSelection = result;
+		
 		// parameters
 		boolean drawBars = specificitiesSelection.isDrawingBars();
 		boolean drawLines = specificitiesSelection.isDrawingLines();
 		
 		JFreeChart chart = null;
-
-
+		
+		
 		// Create the data set
 		XYSeriesCollection dataset = new XYSeriesCollection();
-
-        if(drawBars)	{
+		
+		if (drawBars) {
 			// Create the bar chart
-	        chart = this.getChartsEngine().createXYBarChart(dataset, specificitiesSelection.getName(), SpecificitiesCoreMessages.part, SpecificitiesCoreMessages.score, true, false);
-        }
-        else	{
+			chart = this.getChartsEngine().createXYBarChart(dataset, specificitiesSelection.getName(), SpecificitiesCoreMessages.part, SpecificitiesCoreMessages.score, true, false);
+		}
+		else {
 			// Create the line chart
-	        chart = this.getChartsEngine().createXYLineChart(result, dataset, specificitiesSelection.getName(), SpecificitiesCoreMessages.part, SpecificitiesCoreMessages.score,
-	        		true, false, true, true, true, false, false);
-        }
-
+			chart = this.getChartsEngine().createXYLineChart(result, dataset, specificitiesSelection.getName(), SpecificitiesCoreMessages.part, SpecificitiesCoreMessages.score,
+					true, false, true, true, true, false, false);
+		}
+		
 		return chart;
 		
 	}
-
+	
 	@Override
-	public void updateChart(ChartResult result) {
+	public void updateChart(SpecificitiesSelection result) {
 		
-		SpecificitiesSelection specificitiesSelection = (SpecificitiesSelection) result;
+		SpecificitiesSelection specificitiesSelection = result;
 		JFreeChart chart = (JFreeChart) result.getChart();
 		
 		float banality = specificitiesSelection.getBanality();
-
 		
+		
 		// freeze rendering while computing
 		chart.setNotify(false);
-
 		
+		
 		// removes all existing range marker
 		chart.getXYPlot().clearRangeMarkers();
 		
-        // Add positive banality marker
-        Marker marker = new ValueMarker(banality);
-        marker.setPaint(Color.RED);
-        marker.setLabel(SpecificitiesCoreMessages.bind(SpecificitiesCoreMessages.banalityColonP0, banality));
-        marker.setLabelAnchor(RectangleAnchor.TOP_RIGHT);
-        marker.setLabelTextAnchor(TextAnchor.BOTTOM_RIGHT);
-        chart.getXYPlot().addRangeMarker(marker);
-
-
-        // Add negative banality marker
-        marker = new ValueMarker(-banality);
-        marker.setPaint(Color.RED);
-        marker.setLabel(SpecificitiesCoreMessages.bind(SpecificitiesCoreMessages.banalityColonP0, -banality));
-        marker.setLabelAnchor(RectangleAnchor.TOP_RIGHT);
-        marker.setLabelTextAnchor(TextAnchor.BOTTOM_RIGHT);
-        chart.getXYPlot().addRangeMarker(marker);
-
+		// Add positive banality marker
+		Marker marker = new ValueMarker(banality);
+		marker.setPaint(Color.RED);
+		marker.setLabel(SpecificitiesCoreMessages.bind(SpecificitiesCoreMessages.banalityColonP0, banality));
+		marker.setLabelAnchor(RectangleAnchor.TOP_RIGHT);
+		marker.setLabelTextAnchor(TextAnchor.BOTTOM_RIGHT);
+		chart.getXYPlot().addRangeMarker(marker);
 		
+		
+		// Add negative banality marker
+		marker = new ValueMarker(-banality);
+		marker.setPaint(Color.RED);
+		marker.setLabel(SpecificitiesCoreMessages.bind(SpecificitiesCoreMessages.banalityColonP0, -banality));
+		marker.setLabelAnchor(RectangleAnchor.TOP_RIGHT);
+		marker.setLabelTextAnchor(TextAnchor.BOTTOM_RIGHT);
+		chart.getXYPlot().addRangeMarker(marker);
+		
+		
 		// Transpose or not (group by lines or not)
-        if(result.hasParameterChanged(SpecificitiesPreferences.CHART_GROUP_BY_LINES))	{
-        
+		if (result.hasParameterChanged(SpecificitiesPreferences.CHART_GROUP_BY_LINES)) {
+			
 			// Fill the data set
 			XYSeriesCollection dataset = (XYSeriesCollection) chart.getXYPlot().getDataset();
 			dataset.removeAllSeries();
 			String[] xAxisSymbols;
-	
+			
 			// Transpose the data set
 			List<String> types = specificitiesSelection.getSelectedTypeNames();
 			String[] parts = specificitiesSelection.getSelectedPartNames();
-			if (specificitiesSelection.isGroupingByLines())	{
-		        xAxisSymbols = new String[types.size()];
-	
-				for(int i = 0; i < parts.length; i++) {
+			if (specificitiesSelection.isGroupingByLines()) {
+				xAxisSymbols = new String[types.size()];
+				
+				for (int i = 0; i < parts.length; i++) {
 					XYSeries series = new XYSeries(parts[i]);
 					dataset.addSeries(series);
-	
-					for(int j = 0; j < types.size(); j++) {
+					
+					for (int j = 0; j < types.size(); j++) {
 						series.add(j, specificitiesSelection.getSelectedSpecificitiesIndex()[j][i]);
 						// Add X axis symbol
 						xAxisSymbols[j] = types.get(j);
 					}
 				}
-	
+				
 			}
 			else {
-		        xAxisSymbols = new String[parts.length];
-	
-				for(int i = 0; i < types.size(); i++) {
-	
+				xAxisSymbols = new String[parts.length];
+				
+				for (int i = 0; i < types.size(); i++) {
+					
 					XYSeries series = new XYSeries(types.get(i));
 					dataset.addSeries(series);
-	
-					for(int j = 0; j < parts.length; j++) {
+					
+					for (int j = 0; j < parts.length; j++) {
 						series.add(j, specificitiesSelection.getSelectedSpecificitiesIndex()[i][j]);
 						// Add X axis symbol
 						xAxisSymbols[j] = parts[j];
 					}
 				}
 			}
-	
-	        
-	        // Custom range axis for ticks drawing options
-	        double minimumValue = DatasetUtils.findMinimumRangeValue(chart.getXYPlot().getDataset()).doubleValue();
-	        double maximumValue = DatasetUtils.findMaximumRangeValue(chart.getXYPlot().getDataset()).doubleValue();
-	        // Adjust ticks values according to data set contains only positives values or only negatives values
-	        if(minimumValue > 0)	{
-	        	minimumValue = 0;
-	        }
-	        if(maximumValue < 0)	{
-	        	maximumValue = specificitiesSelection.getBanality();
-	        }
-	        // Custom range axis to cut the values to minimum and maximum values
-	        chart.getXYPlot().setRangeAxis(new ExtendedNumberAxis((NumberAxis) chart.getXYPlot().getRangeAxis(), true, true, minimumValue, maximumValue));
 			
-	        chart.getXYPlot().setDomainAxis(new SymbolAxisBetweenTicks(SpecificitiesCoreMessages.part, xAxisSymbols));
-        }
-        
+			
+			// Custom range axis for ticks drawing options
+			double minimumValue = DatasetUtils.findMinimumRangeValue(chart.getXYPlot().getDataset()).doubleValue();
+			double maximumValue = DatasetUtils.findMaximumRangeValue(chart.getXYPlot().getDataset()).doubleValue();
+			// Adjust ticks values according to data set contains only positives values or only negatives values
+			if (minimumValue > 0) {
+				minimumValue = 0;
+			}
+			if (maximumValue < 0) {
+				maximumValue = specificitiesSelection.getBanality();
+			}
+			// Custom range axis to cut the values to minimum and maximum values
+			chart.getXYPlot().setRangeAxis(new ExtendedNumberAxis((NumberAxis) chart.getXYPlot().getRangeAxis(), true, true, minimumValue, maximumValue));
+			
+			chart.getXYPlot().setDomainAxis(new SymbolAxisBetweenTicks(SpecificitiesCoreMessages.part, xAxisSymbols));
+		}
+		
 		super.updateChart(result);
 		
 	}
 	
-
+	
 	@Override
-	public Class getResultDataClass() {
+	public Class<SpecificitiesSelection> getResultDataClass() {
 		return SpecificitiesSelection.class;
 	}
 	
-
 	
 	
-
-}
\ No newline at end of file
+	
+	
+}
